
package org.objectweb.fractal.cecilia.adl.attributes;

import java.util.Map;

import org.objectweb.fractal.adl.attributes.Attribute;

/** Attribute builder interface. */
public interface AttributeBuilder {

  /**
   * Sets all the given attributes.
   * 
   * @param componentType the type of the component.
   * @param componentInstance the component instance.
   * @param attributeAST an object that gives access to the AST of the attribute
   *            signature (fields, types, values)
   * @param fields the attribute fields.
   * @param codePieces the code pieces that as been produced by builders this
   *            builder depends on.
   * @param context additional parameters.
   * @return the code produced by this builder.
   * @throws Exception if something wrong append.
   */
  Object setAttributes(Object componentType, Object componentInstance,
      Object attributeAST, Attribute[] fields, Map<String, Object> codePieces,
      Map<Object, Object> context) throws Exception;
}
