/***
 * Cecilia ADL Compiler
 * Copyright (C) 2006-2007 STMicroelectronics
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Contact: fractal@objectweb.org
 *
 * Author: Matthieu Leclercq
 */

package org.objectweb.fractal.cecilia.adl.components;

import java.util.Map;

import org.objectweb.fractal.adl.components.PrimitiveCompiler;
import org.objectweb.fractal.cecilia.adl.plugin.AbstractPluginUser;
import org.objectweb.fractal.cecilia.adl.plugin.PluginException;

/**
 * Extention of {@link AbstractPluginUser} for component that uses plugins
 * providing the {@link PrimitiveCompiler} interface.
 */
public abstract class AbstractPrimitiveCompilerPluginUser
    extends
      AbstractPluginUser {

  /** The name of the client compiler plugin(s). */
  public static final String CLIENT_COMPILER_ITF = "client-compiler";

  protected AbstractPrimitiveCompilerPluginUser() {
    super(CLIENT_COMPILER_ITF);
  }

  protected PrimitiveCompiler getPrimitiveCompilerPlugin(
      final Object pluginDesc, final Map<Object, Object> context)
      throws PluginException {
    return getPlugin(pluginDesc, context, PrimitiveCompiler.class);
  }
}
